{{   joystick must be in separate cog
    ********************************************
    *  Author: Larry McGrew                    *      
    ********************************************
    Both 'x' and 'y' display "1" when joystick is centered
    Both 'x' and 'y' only go to "15", not "16"
}}
CON  
    _clkmode = xtal1 + pll16x   
    _xinfreq = 5_000_000

  DebounceTime = 80_000_000/20  
  
VAR     
   byte mode_select 
   long debounce, pin, pinflag
   
OBJ  
  pst : "Parallax Serial Terminal"
  js  : "Buggy joystick" 

PUB Main
   pst.Start(115_200)
   waitcnt(clkfreq*2+cnt)     
   dira[14]~~             
   dira[16]~~
   dira[18]~~
 
   js.Start      
   repeat
     PressButton
     case  mode_select             'default = 0
       0 : outa[14..18] := %00001           
           Motor_Mode            
       1 : outa[14..18] := %00100                   
   '        Flash_LED
       2 : outa[14..18] := %10000
   '        Servo_Mode    
     pst.Str(String(pst#cs, pst#NL, pst#HM, "mode_select= "))  
     pst.Dec(mode_select) 

PUB PressButton    

     pin := js.GetBP                 'read the pin
     if pin == 1                     'is the pin high?
       waitcnt(DebounceTime+cnt)     'wait
       pin := js.GetBP               'read the pin      
       if pin == 1                   'is the pin still high?
         repeat until js.GetBP == 0             
         mode_select := ++pinflag//3 'change the mode     

PUB Motor_Mode | Fwd_Bkwd, Rt_Lft

    Fwd_Bkwd := js.GetFB 
    Rt_Lft  := js.GetRL
    
    pst.Str(String(pst#NL, "Fwd_Bkwd = "))
    pst.Dec(js.GetFB ) 
    pst.Str(String(pst#NL, "Rt_Lft = "))
    pst.Dec(js.GetRL)
    waitcnt(clkfreq/2+cnt)
          